jQuery(function($){
    
	var listaoperaciones = {"irArbolPG":{
    		name: $.rup.i18n.app.ab39a_botonera.xehetasuna,
    		enabled: function(){	
    			return true;
    		},
    		callback: function(key, options){	
    			irArbolPG();
    		}
    	}
	};
	
	if (usuarioConectado===USUARIO_TEC_ENTIDAD){
		listaoperaciones["copiarPlanG"] = {
				name: $.rup.i18n.app.ab39a_botonera.copiarplang,
				enabled: function(){
					return true;
				},
				callback: function(key, options){	
					abrirCopiarPlanGDialog();
				}
			};
		
	}
	
	$('.esNumero').on('input', function () { 
	    this.value = this.value.replace(/[^0-9]/g,'');
	});
	
	$("#PlanesGestion").rup_table({	
		url: $.rup.CTX_PATH + "planesgestion",
		colNames: [
			"codplang",
			$.rup.i18n.app.campos_tabla_planes_gestion["nombreEntidad"],
			$.rup.i18n.app.campos_tabla_planes_gestion["nombrePlanE"],
			$.rup.i18n.app.campos_tabla_planes_estrategicos["fechas"],
			$.rup.i18n.app.campos_tabla_planes_gestion["anyo"],
			$.rup.i18n.app.campos_tabla_planes_gestion["nombre"],
			$.rup.i18n.app.campos_tabla_planes_gestion["fechaModificacion"]
		],
		colModel: [
			{ 	name: "codplang",
				index: "CODPLANG",
				align: "left",
				width: 150,
				hidden: true,
				sortable: true
			},
			{ 	name: "planesEstrategicos.entidad.desentidad",
				index: "DESENTIDAD",
				align: "left",
				width: 150,
				hidden: false,
				sortable: true
			},
			{ 	name: "planesEstrategicos.nombreEsEu",
				index: "NOMBRE"+IDIOMA,
				align: "left",
				width: 150,
				hidden: false,
				sortable: true
			},			
			{ 	name: "planesEstrategicos.anyos",
				index: "anyoinicio",
				align: "left",
				width: 60,
				hidden: false,
				sortable: true
			},
			{ 	name: "anyo",
				index: "ANYO",
				align: "left",
				width: 50,
				hidden: false,
				sortable: true
			},
			{ 	name: "nombreEsEu",
				index: "NOMBRE"+IDIOMA,
				align: "left",
				width: 130,
				hidden: false,
				sortable: true
			},
			{ 	name: "fechaModificacion",
				index: "FECHAMODIFICACION",
				align: "center",
				width: 100,
				hidden: false,
				sortable: true
			}
        ],

        model:"PlanesGestion",
        usePlugins:[
			"formEdit",
        	"feedback",
			"toolbar",
        	"contextMenu",
        	"responsive",
        	"filter"
         	],
		primaryKey: "codplang",
		sortname: "FECHAMODIFICACION",
		sortorder: "DESC",
		loadOnStartUp: true,
		feedback:{
			config:{
				block: false
			}
		},
		core:{
	    	showOperations:{
	    		"clone": false,
	    		"delete": usuarioConectado===USUARIO_TEC_ENTIDAD?true:false,
	    		"edit": false
	    	},
	    	operations:listaoperaciones
    	},
        formEdit:{
        	detailForm: "#PlanesGestion_detail_div",
			addEditOptions: {
    			reloadAfterSubmit:true
    		},
			deleteOptions:{
				reloadAfterSubmit:true
			},
         	validate:{ 
    			rules:{
    				"planesEstrategicos.codplane":{
						required: true
    				},
    				"anyo":{
						required: true, digits:true, maxlength:4, minlength:4
    				},
    				"nombreeus":{
    					required: true
    				}
    			}
    		}
        }
	});
	if(usuarioConectado === USUARIO_TEC_ENTIDAD){
		var codEntidad = entidadObj.codentidad;
		$('#planesestrategicos_detail_table').rup_combo({
			source: $.rup.CTX_PATH + "planesestrategicos/getComboPlanesEs/"+codEntidad,
			sourceParam: {label:"nombreIdiomaAnyo", value:"codplane"},
			blank: "",
			rowStriping: true,
			autocomplete :true
			});
		$("#PlanesGestion").on("jqGridAddEditAfterFillData", function(event, $form, oper){
			if(oper === 'add') {
				//Evento para controlar que se active el campo año cuando se haya seleccionado previamente un plan estrategico
				 $('#planesestrategicos_detail_table').on('change',function(){ 
					var codSeleccionado = $('#planesestrategicos_detail_table').val();
					 if(codSeleccionado===VACIO){
						 $("[id='anyo_detail_table']").prop('readonly', true);
					 }
					 else{
						 $("[id='anyo_detail_table']").prop('readonly', false);
						 
						 //Cargar los campos de los años del plan estrategico
						 $.rup_ajax({
								url : $.rup.CTX_PATH + "planesestrategicos/getFechas/"+codSeleccionado,
								contentType : "application/json",
								cache : false,
								dataType : "json",
								type : "GET",
								success : function(response) {
									$('#planesestrategicos_anyoinicio_detail_table').val(response.anyoinicio);
									$('#planesestrategicos_anyofin_detail_table').val(response.anyofin);
								},
								error : function(error) {
									ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorCargaFechasPlanE"]);
								}
							});
					 }
				 });
			}
		});
		if(solicInfor == 1){
			$(".idiomaEs").hide();
		}else{
			$(".idiomaEs").show();
		}
	}

	//Evento para controlar que se active el campo año cuando se haya seleccionado previamente un plan estrategico
	 $('#planesestrategicos_detail_table').on('change',function(){ 
		 var codSeleccionado = $('#planesestrategicos_detail_table').val();
		 if(codSeleccionado===VACIO){
			 $("[id='anyo_detail_table']").prop('readonly', true);
		 }
		 else{
			 $("[id='anyo_detail_table']").prop('readonly', false);
			 
			 //Cargar los campos de los años del plan estrategico
			 $.rup_ajax({
					url : $.rup.CTX_PATH + "planesestrategicos/getFechas/"+codSeleccionado,
					contentType : "application/json",
					cache : false,
					dataType : "json",
					type : "GET",
					success : function(response) {
						$('#planesestrategicos_anyoinicio_detail_table').val(response.anyoinicio);
						$('#planesestrategicos_anyofin_detail_table').val(response.anyofin);
					},
					error : function(error) {
						ab39aUtils.feedback.pintarFeedbackError($.rup.i18n.app.errores["errorCargaFechasPlanE"]);
					}
				});
		 }
	 });
	 

	 $("#PlanesGestion").rup_table('setGridParam',{ ondblClickRow : function(rowid){ redirigir_xehetasuna(); } });
		
		function redirigir_xehetasuna(){
			irArbolPG();
		}
	 
	 if(usuarioConectado == USUARIO_TEC_ENTIDAD){
		 $("[id='PlanesGestion_toolbar##btnAdd']").show();
	 }
	 else{
		 $("[id='PlanesGestion_toolbar##btnAdd']").hide();
	 }
	
});


function irArbolPG(){	
	var selectedRow = ab39aUtils.tabla.getSelectedRow($("#PlanesGestion"));
	var celdaSeleccionada = $("#PlanesGestion").rup_table("getSelectedRows");
	if (celdaSeleccionada[0]!=undefined) {	
		window.location = $.rup.CTX_PATH + "elementosArbol/arbol/detalle/" + selectedRow.codplang + "/PG/0/0";
	}	
}


function abrirCopiarPlanGDialog(){
	ab39aUtils.util.bloquearInterfaz();
	$('#divCopiarPlanG_Dialog').rup_dialog({
		title :$.rup.i18n.app.campos_tabla_planes_gestion['copiarPlanGTitulo'],
		type: $.rup.dialog.AJAX, 
		url: ab39aUtils.util.setUrlNoCachePortalWar($.rup.CTX_PATH + "planesgestion/copiarplang"),
		autoOpen : true,
		closeOnEscape : true,
		modal : true,
		resizable : false,
		minWidth : 1700,
		minHeight : 300,
		ajaxOptions: {
			success: function (data, textStatus, XMLHttpRequest){

			},
			error: function (error){
			}
		},
		open: function(){
			
		},
		load: function(){
			ab39aUtils.util.desbloquearInterfaz();
		},
		close: function(event, ui) { 
			//ab39aUtils.util.desbloquearInterfaz();
			//Parche para saber si se ha abierto en algun momento la capa. Si no es así, entonces no tengo que destruirla
			if($('#divCopiarAltaPlanG_Dialog')[0].innerHTML!=="&nbsp;"){
				$('#divCopiarAltaPlanG_Dialog').rup_dialog("destroy");
				$("#PlanesGestion").rup_table("reloadGrid", true);
			}
		}
	});	
	
	
}